package com.osc.front.controller;

package ..deTemp.1749444222409;

import com.osc.common.core.utils.DateUtils;
import com.osc.common.core.utils.StringUtils;
import com.osc.common.core.web.controller.BaseController;
import com.osc.common.security.annotation.InnerAuth;
import com.osc.front.domain.OscOrder;
import com.osc.front.domain.OscOrderDetails;
import com.osc.front.service.IAccService;
import com.osc.front.service.ICqCardService;
import com.osc.front.service.IOscAreaYearCheckService;
import com.osc.front.service.IOscCityYearCheckService;
import com.osc.front.service.IOscOrderDetailsService;
import com.osc.front.service.IOscOrderService;
import com.osc.front.service.IOscSeCardOrderService;
import com.osc.front.service.impl.SupportServiceImpl;
import com.osc.front.service.impl.TkTrafficCardSevice;
import com.osc.system.api.RemoteOscAppVersionService;
import com.osc.system.api.RemoteReceiptService;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping({"/frontApi"})
public class InterFaceApiContorller extends BaseController {
  @Autowired
  private IOscOrderService oscOrderService;
  
  @Autowired
  private IOscOrderDetailsService oscOrderDetailsService;
  
  @Autowired
  private ICqCardService cqCardService;
  
  @Autowired
  private SupportServiceImpl supportService;
  
  @Autowired
  private IAccService iAccService;
  
  @Autowired
  private RemoteOscAppVersionService iOscAppVersionService;
  
  @Autowired
  private RemoteReceiptService remoteReceiptService;
  
  @Autowired
  private IOscAreaYearCheckService oscAreaYearCheckService;
  
  @Autowired
  private IOscCityYearCheckService oscCityYearCheckService;
  
  @Autowired
  private TkTrafficCardSevice tkTrafficCardSevice;
  
  @Autowired
  private IOscSeCardOrderService oscSeCardOrderService;
  
  @InnerAuth
  @PostMapping({"/checkCardInfo"})
  public Map<String, Object> checkCardInfo(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.checkCardInfo(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/appRefundSEOrder"})
  public Map<String, Object> appRefundSEOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.appRefundSEOrder(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/seUnFinishedOrder"})
  public Map<String, Object> seUnFinishedOrder(@RequestBody Map<String, Object> mapInfo) {
    String userId = StringUtils.valueOf(mapInfo.get("userId"));
    Map<String, Object> resMap = this.oscSeCardOrderService.seUnFinishedOrder(userId);
    mapInfo.put("orderList", resMap.get("orderList"));
    return mapInfo;
  }
  
  @InnerAuth
  @PostMapping({"/checkTK"})
  public Map<String, Object> checkTK(@RequestBody Map<String, Object> mapInfo) {
    Map<String, Object> resMap = this.oscSeCardOrderService.checkTK(mapInfo);
    return resMap;
  }
  
  @InnerAuth
  @PostMapping({"/refundSEOrderOne"})
  public Map<String, Object> refundSEOrderOne(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.refundSEOrderOne(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/returnCard"})
  public Map<String, Object> returnCard(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.returnCard(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/bindSECard"})
  public Map<String, Object> bindSECard(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.bindSECard(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/bindSECardList"})
  public Map<String, Object> bindSECardList(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.bindSECardList(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/createAppSeOrder"})
  public Map<String, Object> createAppSeOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.oscSeCardOrderService.createAppSeOrder(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/jobPushAcc"})
  public void jobPushAcc(@RequestBody Map<String, String> mapInfo) {
    this.iAccService.jobPushAcc(mapInfo.get("businessOrderNo"), mapInfo.get("pushDate"));
  }
  
  @InnerAuth
  @PostMapping({"/changeAccPin"})
  public Map<String, Object> changeAccPin(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.changeAccPin(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/updateTac"})
  public void updateTac(@RequestBody Map<String, String> mapInfo) {
    OscOrder oscOrder = new OscOrder();
    oscOrder.setId(Long.valueOf(mapInfo.get("oscOrderId")));
    this.cqCardService.updateTac(oscOrder, StringUtils.valueOf(mapInfo.get("tac")), "02");
  }
  
  @InnerAuth
  @PostMapping({"/jobPush"})
  public void jobPush(@RequestBody Map<String, String> mapInfo) {}
  
  @InnerAuth
  @PostMapping({"/areaNianJianStatistics"})
  public void areaNianJianStatistics(@RequestBody Map<String, String> mapInfo) {
    this.oscAreaYearCheckService.areaNianJianStatistics(mapInfo.get("sDate"));
  }
  
  @InnerAuth
  @PostMapping({"/cityNianJianStatistics"})
  public void cityNianJianStatistics(@RequestBody Map<String, String> mapInfo) {
    this.oscCityYearCheckService.cityNianJianStatistics(mapInfo.get("sDate"));
  }
  
  public int putInvoiceOrder(String data) {
    OscOrder oscOrder = new OscOrder();
    oscOrder.setIsReceive("0");
    oscOrder.setOrderStatus("08");
    List<String> orderTypes = new ArrayList<>();
    orderTypes.add("01");
    orderTypes.add("02");
    int count = 0;
    List<OscOrder> oscOrders = this.oscOrderService.selectOscOrderList(oscOrder);
    for (OscOrder info : oscOrders) {
      Map<String, Object> fapiao = new HashMap<>();
      fapiao.put("cardNo", info.getCardNo());
      Map<String, Object> map = this.remoteReceiptService.uploadReceipt(fapiao, "inner");
      if ("000000".equals(String.valueOf(map.get("respCode"))))
        count++; 
    } 
    return count;
  }
  
  @InnerAuth
  @PostMapping({"/insertOscOrderDetails"})
  public int insertOscOrderDetails(@RequestBody Map<String, String> mapInfo) {
    OscOrder oscOrder = new OscOrder();
    oscOrder.setBusinessOrderNo(mapInfo.get("businessOrder"));
    List<OscOrder> oscOrders = this.oscOrderService.selectOscOrderList(oscOrder);
    if (oscOrders.size() > 0) {
      OscOrderDetails oscOrderDetails = new OscOrderDetails();
      oscOrder = oscOrders.get(0);
      oscOrderDetails.setOscOrderId(oscOrder.getId());
      oscOrderDetails.setTransactionDec(mapInfo.get("transactionDec"));
      oscOrderDetails.setTransactionType(mapInfo.get("transactionType"));
      oscOrderDetails.setResponseCode(mapInfo.get("resCode"));
      oscOrderDetails.setAppExprDate(mapInfo.get("appExprDate"));
      String appEffcDate = mapInfo.get("appEffcDate");
      if (StringUtils.isNotEmpty(appEffcDate)) {
        oscOrderDetails.setAppEffcDate(appEffcDate);
      } else {
        oscOrderDetails.setAppEffcDate(oscOrder.getCardStartDate());
      } 
      oscOrderDetails.setTransactionDate(DateUtils.getNowDate());
      return this.oscOrderDetailsService.insertOscOrderDetails(oscOrderDetails);
    } 
    return 0;
  }
  
  @InnerAuth
  @PostMapping({"/logOffUser"})
  public int logOffUser(@RequestBody String userId) {
    int i = this.oscOrderService.logOffUser(userId);
    this.logger.info("-----logOffUser-----" + i);
    return i;
  }
  
  @InnerAuth
  @PostMapping({"/queryElecwallet"})
  public Map<String, Object> queryElecwallet(@RequestBody Map<String, Object> mapInfo) {
    return this.supportService.queryElecwallet(mapInfo, "");
  }
  
  @InnerAuth
  @PostMapping({"/updateOrder"})
  public Map<String, Object> updateOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.oscOrderService.updateOscOrderByBuniessNo(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/LoadedOrder"})
  public Map<String, Object> LoadedOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.LoadedOrder(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/CardInitialization"})
  public Map<String, Object> CardInitialization(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.CardInitialization(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/terminalInitialization"})
  public Map<String, Object> terminalInitialization(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.terminalInitialization(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/HousingCheckPin"})
  public Map<String, Object> HousingCheckPin(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.HousingCheckPin(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/HousingMac"})
  public Map<String, Object> HousingMac(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.HousingMac(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/TrafficMac"})
  public Map<String, Object> TrafficMac(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.TrafficMac(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/HousingCheckTac"})
  public Map<String, Object> HousingCheckTac(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.HousingCheckTac(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/TrafficTac"})
  public Map<String, Object> TrafficTac(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.TrafficTac(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/HousingMonthlyTicket"})
  public Map<String, Object> HousingMonthlyTicket(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.HousingMonthlyTicket(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/WalletTransaction"})
  public Map<String, Object> WalletTransaction(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.WalletTransaction(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/TrafficMonthlyTicket"})
  public Map<String, Object> TrafficMonthlyTicket(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.TrafficMonthlyTicket(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/RecordCardUpload"})
  public Map<String, Object> RecordCardUpload(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.RecordCardUpload(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/ApplyRefundOrder"})
  public Map<String, Object> ApplyRefundOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.ApplyRefundOrder(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/decryptIdacrd"})
  public Map<String, Object> decryptIdacrd(@RequestBody Map<String, Object> mapInfo) {
    return this.cqCardService.decryptIdacrd(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/myOrderDetail"})
  public Map<String, Object> myOrderDetail(@RequestBody Map<String, Object> mapInfo) {
    return this.oscOrderService.myOrderDetail(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/myOrder"})
  public Map<String, Object> myOrder(@RequestBody Map<String, Object> mapInfo) {
    return this.oscOrderService.myOrder(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/trafficCardPayNotify"})
  public Map<String, String> trafficCardPayNotify(@RequestBody Map<String, String> mapInfo) {
    return this.tkTrafficCardSevice.trafficCardPayNotify(mapInfo);
  }
  
  @InnerAuth
  @PostMapping({"/cardTxnSocial"})
  public Map<String, Object> cardTxnSocial(@RequestBody Map<String, Object> mapInfo) throws UnsupportedEncodingException {
    return this.cqCardService.cardTxnSocial(mapInfo);
  }
}
